Index: src/Actions/WorldAction/InputAction.cpp
===================================================================
--- src/Actions/WorldAction/InputAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/InputAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * InputAction.cpp
@@ -6,13 +13,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/InputAction.hpp"
-#include "Actions/ActionRegistry.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "Parser/FormatParserStorage.hpp"
 #include "Parser/PcpParser.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -22,46 +32,26 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/WorldAction/InputAction.hpp"
 
-const char WorldInputAction::NAME[] = "input";
-
-WorldInputAction::WorldInputAction() :
-  Action(NAME)
-{}
-
-WorldInputAction::~WorldInputAction()
-{}
-
-void WorldInput(std::string &filename) {
-  ValueStorage::getInstance().setCurrentValue(WorldInputAction::NAME, filename);
-  ActionRegistry::getInstance().getActionByName(WorldInputAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* WorldInputAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "InputAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr WorldInputAction::performCall() {
   MoleculeListClass *molecules = World::getInstance().getMolecules();
   molecule *mol = NULL;
-  std::string filename;
   std::ifstream test;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
+  // obtain information
+  getParametersfromValueStorage();
 
   DoLog(0) && (Log() << Verbose(0) << "Config file given." << endl);
-  if (filename.find('.') != string::npos) {
-    std::string FilenamePrefix = filename.substr(0,filename.find_last_of('.'));
-    std::string FilenameSuffix = filename.substr(filename.find_last_of('.')+1, filename.length());
+  if (params.filename.find('.') != string::npos) {
+    std::string FilenamePrefix = params.filename.substr(0,params.filename.find_last_of('.'));
+    std::string FilenameSuffix = params.filename.substr(params.filename.find_last_of('.')+1, params.filename.length());
     DoLog(1) && (Log() << Verbose(1) << "Setting config file name prefix to " << FilenamePrefix << "." << endl);
-    test.open(filename.c_str());
+    test.open(params.filename.c_str());
     if (test == NULL) {
-      DoLog(1) && (Log() << Verbose(1) << "Specified config file " << filename << " not found." << endl);
+      DoLog(1) && (Log() << Verbose(1) << "Specified config file " << params.filename << " not found." << endl);
     } else {
       DoLog(1) && (Log() << Verbose(1) << "Specified config file found, parsing ... ");
@@ -83,5 +73,5 @@
       molecules->insert(mol);
     }
-    mol->SetNameFromFilename(filename.substr(0,filename.find('.')).c_str());
+    mol->SetNameFromFilename(params.filename.substr(0,params.filename.find('.')).c_str());
   } else {
     DoeLog(1) && (eLog() << Verbose(1) << "Input file does not have a suffix, cannot recognize format." << endl);
@@ -115,2 +105,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/InputAction.def
===================================================================
--- src/Actions/WorldAction/InputAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/InputAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * InputAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (WorldInputAction::NAME)
+#define paramreferences (filename)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME Input
+#define TOKEN "input"
+
Index: src/Actions/WorldAction/InputAction.hpp
===================================================================
--- src/Actions/WorldAction/InputAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/InputAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void WorldInput(std::string &filename);
-
-class WorldInputAction : public Action {
-  friend void WorldInput(std::string &filename);
-
-public:
-  WorldInputAction();
-  virtual ~WorldInputAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "InputAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* INPUTACTION_HPP_ */
Index: src/Actions/WorldAction/OutputAction.cpp
===================================================================
--- src/Actions/WorldAction/OutputAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/OutputAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * OutputAction.cpp
@@ -6,11 +13,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/OutputAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Parser/ChangeTracker.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -20,30 +30,13 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/WorldAction/OutputAction.hpp"
 
-const char WorldOutputAction::NAME[] = "output";
-
-WorldOutputAction::WorldOutputAction() :
-  Action(NAME)
-{}
-
-WorldOutputAction::~WorldOutputAction()
-{}
-
-void WorldOutput() {
-  ActionRegistry::getInstance().getActionByName(WorldOutputAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* WorldOutputAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "OutputAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr WorldOutputAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
   DoLog(0) && (Log() << Verbose(0) << "Saving world to files." << endl);
@@ -77,2 +70,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/OutputAction.def
===================================================================
--- src/Actions/WorldAction/OutputAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/OutputAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * OutputAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME Output
+#define TOKEN "output"
+
Index: src/Actions/WorldAction/OutputAction.hpp
===================================================================
--- src/Actions/WorldAction/OutputAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/OutputAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void WorldOutput();
-
-class WorldOutputAction : public Action {
-  friend void WorldOutput();
-
-public:
-  WorldOutputAction();
-  virtual ~WorldOutputAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "OutputAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* OUTPUTACTION_HPP_ */
Index: src/Actions/WorldAction/RepeatBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/RepeatBoxAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/RepeatBoxAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * RepeatBoxAction.cpp
@@ -6,14 +13,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/RepeatBoxAction.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/MoleculePtrDescriptor.hpp"
 #include "atom.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
-#include "Matrix.hpp"
-#include "verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 #include "Box.hpp"
@@ -21,37 +32,15 @@
 #include <iostream>
 #include <string>
+#include <vector>
 
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
-#include "Descriptors/MoleculeDescriptor.hpp"
-#include "Descriptors/MoleculePtrDescriptor.hpp"
+#include "Actions/WorldAction/RepeatBoxAction.hpp"
 
-const char WorldRepeatBoxAction::NAME[] = "repeat-box";
-
-WorldRepeatBoxAction::WorldRepeatBoxAction() :
-  Action(NAME)
-{}
-
-WorldRepeatBoxAction::~WorldRepeatBoxAction()
-{}
-
-void WorldRepeatBox(Vector &Repeater) {
-  ValueStorage::getInstance().setCurrentValue(WorldRepeatBoxAction::NAME, Repeater);
-  ActionRegistry::getInstance().getActionByName(WorldRepeatBoxAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog * WorldRepeatBoxAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "RepeatBoxAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr WorldRepeatBoxAction::performCall() {
-  Vector Repeater;
   int count;
   const element ** Elements;
@@ -61,5 +50,6 @@
   MoleculeListClass *molecules = World::getInstance().getMolecules();
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, Repeater);
+  // obtain information
+  getParametersfromValueStorage();
 
   vector<molecule *> AllMolecules;
@@ -72,5 +62,5 @@
   }
 
-  (cout << "Repeating box " << Repeater << " times for (x,y,z) axis." << endl);
+  (cout << "Repeating box " << params.Repeater << " times for (x,y,z) axis." << endl);
   Matrix M = World::getInstance().getDomain().getM();
   Matrix newM = M;
@@ -79,10 +69,10 @@
   Matrix repMat;
   for (int axis = 0; axis < NDIM; axis++) {
-    Repeater[axis] = floor(Repeater[axis]);
-    if (Repeater[axis] < 1) {
+    params.Repeater[axis] = floor(params.Repeater[axis]);
+    if (params.Repeater[axis] < 1) {
       DoeLog(1) && (eLog()<< Verbose(1) << "Repetition factor must be greater than 1!" << endl);
-      Repeater[axis] = 1;
+      params.Repeater[axis] = 1;
     }
-    repMat.at(axis,axis) = Repeater[axis];
+    repMat.at(axis,axis) = params.Repeater[axis];
   }
   newM *= repMat;
@@ -90,10 +80,10 @@
 
   molecule *newmol = NULL;
-  Vector ** vectors = NULL;
-  for (n[0] = 0; n[0] < Repeater[0]; n[0]++) {
+  std::vector<Vector> vectors;
+  for (n[0] = 0; n[0] < params.Repeater[0]; n[0]++) {
     y[0] = n[0];
-    for (n[1] = 0; n[1] < Repeater[1]; n[1]++) {
+    for (n[1] = 0; n[1] < params.Repeater[1]; n[1]++) {
       y[1] = n[1];
-      for (n[2] = 0; n[2] < Repeater[2]; n[2]++) {
+      for (n[2] = 0; n[2] < params.Repeater[2]; n[2]++) {
         y[2] = n[2];
         if ((n[0] == 0) && (n[1] == 0) && (n[2] == 0))
@@ -105,9 +95,9 @@
           if (count != 0) {  // if there is more than none
             Elements = new const element *[count];
-            vectors = new Vector *[count];
+            vectors.resize(count);
             j = 0;
             for(molecule::iterator AtomRunner = mol->begin(); AtomRunner != mol->end(); ++AtomRunner) {
-              Elements[j] = (*AtomRunner)->type;
-              vectors[j] = &(*AtomRunner)->x;
+              Elements[j] = (*AtomRunner)->getType();
+              vectors[j] = (*AtomRunner)->getPosition();
               j++;
             }
@@ -120,6 +110,6 @@
             for (int k=count;k--;) { // go through every atom of the original cell
               Walker = World::getInstance().createAtom(); // create a new body
-              Walker->x = (*vectors[k]) + x;
-              Walker->type = Elements[k];  // insert original element
+              Walker->setPosition((vectors[k]) + x);
+              Walker->setType(Elements[k]);  // insert original element
               cout << "new atom is " << *Walker << endl;
               newmol->AddAtom(Walker);        // and add to the molecule (which increments ElementsInMolecule, AtomCount, ...)
@@ -127,5 +117,4 @@
             // free memory
             delete[](Elements);
-            delete[](vectors);
           } else {
             DoLog(1) && (Log() << Verbose(1) << "\t ... is empty." << endl);
@@ -163,2 +152,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/RepeatBoxAction.def
===================================================================
--- src/Actions/WorldAction/RepeatBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/RepeatBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * RepeatBoxAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "LinearAlgebra/Vector.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (Vector)
+#define paramtokens (WorldRepeatBoxAction::NAME)
+#define paramreferences (Repeater)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME RepeatBox
+#define TOKEN "repeat-box"
+
Index: src/Actions/WorldAction/RepeatBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/RepeatBoxAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/RepeatBoxAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,28 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "vector.hpp"
 
-void WorldRepeatBox(Vector &Repeater);
-
-class WorldRepeatBoxAction : public Action {
-  friend void WorldRepeatBox(Vector &Repeater);
-
-public:
-  WorldRepeatBoxAction();
-  virtual ~WorldRepeatBoxAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "RepeatBoxAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* REPEATBOXACTION_HPP_ */
Index: src/Actions/WorldAction/ScaleBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/ScaleBoxAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/ScaleBoxAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ScaleBoxAction.cpp
@@ -6,15 +13,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/ScaleBoxAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
-#include "log.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 #include "Box.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 
 #include <iostream>
@@ -23,42 +33,22 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/WorldAction/ScaleBoxAction.hpp"
 
-const char WorldScaleBoxAction::NAME[] = "scale-box";
-
-WorldScaleBoxAction::WorldScaleBoxAction() :
-  Action(NAME)
-{}
-
-WorldScaleBoxAction::~WorldScaleBoxAction()
-{}
-
-void WorldScaleBox(Vector &Scaler) {
-  ValueStorage::getInstance().setCurrentValue(WorldScaleBoxAction::NAME, Scaler);
-  ActionRegistry::getInstance().getActionByName(WorldScaleBoxAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* WorldScaleBoxAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "ScaleBoxAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr WorldScaleBoxAction::performCall() {
-  Vector Scaler;
   double x[NDIM];
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, Scaler);
+  // obtain information
+  getParametersfromValueStorage();
 
   DoLog(1) && (Log() << Verbose(1) << "Scaling all atomic positions by factor." << endl);
   for (int i=0;i<NDIM;i++)
-    x[i] = Scaler[i];
+    x[i] = params.Scaler[i];
   vector<atom*> AllAtoms = World::getInstance().getAllAtoms();
   for(vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner) {
-    (*AtomRunner)->x.ScaleAll(x);
+    (*AtomRunner)->ScaleAll(x);
   }
 
@@ -100,2 +90,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/ScaleBoxAction.def
===================================================================
--- src/Actions/WorldAction/ScaleBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/ScaleBoxAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * ScaleBoxAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "LinearAlgebra/Vector.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (Vector)
+#define paramtokens (WorldScaleBoxAction::NAME)
+#define paramreferences (Scaler)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME ScaleBox
+#define TOKEN "scale-box"
+
Index: src/Actions/WorldAction/ScaleBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/ScaleBoxAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/ScaleBoxAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,28 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "vector.hpp"
 
-void WorldScaleBox(Vector &Scaler);
-
-class WorldScaleBoxAction : public Action {
-  friend void WorldScaleBox(Vector &Scaler);
-
-public:
-  WorldScaleBoxAction();
-  virtual ~WorldScaleBoxAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "ScaleBoxAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* SCALEBOXACTION_HPP_ */
Index: src/Actions/WorldAction/SetDefaultNameAction.cpp
===================================================================
--- src/Actions/WorldAction/SetDefaultNameAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/SetDefaultNameAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * SetDefaultNameAction.cpp
@@ -6,10 +13,13 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/WorldAction/SetDefaultNameAction.hpp"
-#include "Actions/ActionRegistry.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -19,52 +29,21 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/WorldAction/SetDefaultNameAction.hpp"
 
+// and construct the stuff
+#include "SetDefaultNameAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr WorldSetDefaultNameAction::performCall() {
+  string Worldsdefaultname;
+  Worldsdefaultname = World::getInstance().getDefaultName();
+  WorldSetDefaultNameState *UndoState = new WorldSetDefaultNameState(Worldsdefaultname, params);
 
-// memento to remember the state when undoing
+  // obtain information
+  getParametersfromValueStorage();
 
-class WorldSetDefaultNameState : public ActionState {
-public:
-  WorldSetDefaultNameState(std::string _lastName) :
-    lastName(_lastName)
-  {}
-  std::string lastName;
-};
-
-const char WorldSetDefaultNameAction::NAME[] = "default-molname";
-
-WorldSetDefaultNameAction::WorldSetDefaultNameAction() :
-  Action(NAME)
-{}
-
-WorldSetDefaultNameAction::~WorldSetDefaultNameAction()
-{}
-
-void WorldSetDefaultName(std::string &defaultname) {
-  ValueStorage::getInstance().setCurrentValue(WorldSetDefaultNameAction::NAME, defaultname);
-  ActionRegistry::getInstance().getActionByName(WorldSetDefaultNameAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* WorldSetDefaultNameAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  string defaultname = World::getInstance().getDefaultName();
-  ValueStorage::getInstance().setCurrentValue(NAME, defaultname);
-  dialog->queryString(NAME, MapOfActions::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr WorldSetDefaultNameAction::performCall() {
-  string defaultname;
-
-  defaultname = World::getInstance().getDefaultName();
-  ValueStorage::getInstance().queryCurrentValue(NAME, defaultname);
-
-  World::getInstance().setDefaultName(defaultname);
+  World::getInstance().setDefaultName(params.newname);
   DoLog(0) && (Log() << Verbose(0) << "Default name of new molecules set to " << World::getInstance().getDefaultName() << "." << endl);
-  return Action::success;
+  return Action::state_ptr(UndoState);
 }
 
@@ -72,12 +51,17 @@
   WorldSetDefaultNameState *state = assert_cast<WorldSetDefaultNameState*>(_state.get());
 
-  string newName = World::getInstance().getDefaultName();
-  World::getInstance().setDefaultName(state->lastName);
+  World::getInstance().setDefaultName(state->lastname);
+  DoLog(0) && (Log() << Verbose(0) << "Default name of new molecules set to " << World::getInstance().getDefaultName() << "." << endl);
 
-  return Action::state_ptr(new WorldSetDefaultNameState(newName));
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr WorldSetDefaultNameAction::performRedo(Action::state_ptr _state){
-  performUndo(_state);
+  WorldSetDefaultNameState *state = assert_cast<WorldSetDefaultNameState*>(_state.get());
+
+  World::getInstance().setDefaultName(state->params.newname);
+  DoLog(0) && (Log() << Verbose(0) << "Default name of new molecules set to " << World::getInstance().getDefaultName() << "." << endl);
+
+  return Action::state_ptr(_state);
 }
 
@@ -93,2 +77,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/SetDefaultNameAction.def
===================================================================
--- src/Actions/WorldAction/SetDefaultNameAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/WorldAction/SetDefaultNameAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * SetDefaultNameAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (WorldSetDefaultNameAction::NAME)
+#define paramreferences (newname)
+
+#define statetypes (std::string)
+#define statereferences (lastname)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define ACTIONNAME SetDefaultName
+#define TOKEN "default-molname"
+
Index: src/Actions/WorldAction/SetDefaultNameAction.hpp
===================================================================
--- src/Actions/WorldAction/SetDefaultNameAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/WorldAction/SetDefaultNameAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void WorldSetDefaultName(std::string &defaultname);
-
-class WorldSetDefaultNameAction : public Action {
-  friend void WorldSetDefaultName(std::string &defaultname);
-
-public:
-  WorldSetDefaultNameAction();
-  virtual ~WorldSetDefaultNameAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "SetDefaultNameAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* SETDEFAULTNAMEACTION_HPP_ */
